<?php // Contact Form X Display Settings

if (!defined('ABSPATH')) exit;

function contactformx_menu_pages() {
	
	// add_options_page( $page_title, $menu_title, $capability, $menu_slug, $function )
	add_options_page(__('Contact Form X', 'contact-form-x'), __('Contact Form X', 'contact-form-x'), 'manage_options', 'contactformx', 'contactformx_display_settings');
	
}

function contactformx_get_tabs() {
	
	$tabs = array(
		'tab1' => esc_html__('Email',      'contact-form-x'), 
		'tab2' => esc_html__('Form',       'contact-form-x'), 
		'tab3' => esc_html__('Customize',  'contact-form-x'), 
		'tab4' => esc_html__('Appearance', 'contact-form-x'), 
		'tab5' => esc_html__('Advanced',   'contact-form-x'), 
	);
	
	return $tabs;
	
}

function contactformx_display_settings() {
	
	$tab_active = isset($_GET['tab']) ? sanitize_text_field($_GET['tab']) : 'tab1'; 
	
	$tab_href = admin_url('options-general.php?page=contactformx');
	
	$tab_names = contactformx_get_tabs();
	
	?>
	
	<div class="wrap wrap-<?php echo $tab_active; ?>">
		<h1><?php esc_html_e('Contact Form', 'contact-form-x'); ?> <span class="cfx-icon">X</span></h1>
		<p><?php esc_html_e('Visit the Help tab above for usage information.', 'contact-form-x'); ?></p>
		<h2 class="nav-tab-wrapper">
			
			<?php 
				
				foreach ($tab_names as $key => $value) {
					
					$active = ($tab_active === $key) ? ' nav-tab-active' : '';
					
					echo '<a href="'. $tab_href .'&tab='. $key .'" class="nav-tab nav-'. $key . $active .'">'. $value .'</a>';
					
				}
				
			?>
			
		</h2>
		<form method="post" action="options.php">
			
			<?php
				
				if ($tab_active === 'tab1') {
					
					settings_fields('contactformx_email');
					do_settings_sections('contactformx_email');
				
				} elseif ($tab_active === 'tab2') {
					
					settings_fields('contactformx_form');
					do_settings_sections('contactformx_form');
					
				} elseif ($tab_active === 'tab3') {
					
					settings_fields('contactformx_customize');
					do_settings_sections('contactformx_customize');
					
				} elseif ($tab_active === 'tab4') {
					
					settings_fields('contactformx_appearance');
					do_settings_sections('contactformx_appearance');
					
				} elseif ($tab_active === 'tab5') {
					
					settings_fields('contactformx_advanced');
					do_settings_sections('contactformx_advanced');
					
				}
				
				submit_button();
				
			?>
			
		</form>
	</div>
	
<?php }
